/****
 * CFingKeyWndPane.h
 *
 *	Fingerspelling key window pane class for the SignWriter key editor.
 *
 *  Copyright  1996 The Center for Sutton Movement Writing.  All rights reserved.
 *
 ****/
 
 

#pragma	once					/* Include only once */


#include "CPane.h"
#include "KeyEditConsts.h"




struct CFingKeyWndPane : CPane {

				/* Key code */
	Byte		itsKeyCode;
	
	
				/* Blink state */
	Boolean		itsOn;

	
				/* Initialization */
	void		IFingKeyWndPane (CView *anEnclosure, CBureaucrat *aSupervisor,
							  	 Byte keyCode);


				/* Selection */
	void		BlinkSelect   (long *maxSleep);
	void	    Deselect      (void);
	void		Deactivate    (void);
	void		Close		  (void);
	ObjType		SelectionType (void);
	
				
				/* Edit commands */
	void		DoCopy  (void);
	void		DoPaste (void);
	void		DoClear (short taskIndex);
	void		DoAdd   (void);

	
				/* Symbol editing */
	void		Setup  (void);
	void		Update (void);
	
	
				/* Symbol commands */
	void		DoChange (void);
	void		DoFill   (void);
	void		DoMirror (void);
	void		DoRotate (void);
	void 		DoCursor (void);
	void		DoSymCommand (Byte keyCode);
	

				/* Drawing */
	void		Draw (Rect *area);
	void		UpdateKey (void);
	void		ToggleBox       (void);
	void		ToggleCursor 	(void);
	void		ToggleSelect	(void);
	void		ToggleDescender (void);


				/* Mouse */
	void		DoClick (Point hitPt, short modifierKeys, long when);

};
