
/******************************************************************************
 CFingKeyWndTask.h

  Fingerspelling key window task classes for the SignWriter key editor.
		
  Copyright 1996 The Center for Sutton Movement Writing. All rights reserved.
		
 ******************************************************************************/
 
 
#pragma once



#include "CTask.h"						/* Superclass for edit tasks */
#include "CMouseTask.h"					/* Superclass for drag tasks */
#include "CFingKeyWndPane.h"
#include "LongQD.h"
#include "Keys.h"




struct CFingKeyWndClear : CTask {	

	CFingKeyWndPane  *itsPane;	
	
	Byte		itsKeyCode;
	

	void		IFingKeyWndClear (short nameIndex, CFingKeyWndPane *pane, Byte keyCode);											       
	void		Do   (void);
	void		Undo (void);
};



struct CFingKeyWndPaste : CTask {	
	
	CFingKeyWndPane  *itsPane;	
	
	Byte		itsKeyCode;
	
	
	void		IFingKeyWndPaste (CFingKeyWndPane *pane, Byte keyCode);		
	
	void		Do   (void);
	void		Undo (void);
};



struct CFingKeyWndAdd : CTask {	
	
	CFingKeyWndPane  *itsPane;	
	
	Byte		itsKeyCode;
	

	void		IFingKeyWndAdd (CFingKeyWndPane *pane, Byte keyCode);		
	
	void		Do   (void);
	void		Undo (void);
};



struct CFingKeyWndDrag : CMouseTask {


	CFingKeyWndPane  *itsPane;	
	Byte	 		 *itsBase;
	LongPt	 		 itsFrame, itsTrackEnd;
	
	
	void		IFingKeyWndDrag (CFingKeyWndPane *pane, Box key, short symInx);
	
	void		BeginTracking (LongPt *startPt);
	void		KeepTracking  (LongPt *currPt, LongPt *prevPt, LongPt *startPt);
	
};



struct CFingKeyWndDesc : CMouseTask {


	CFingKeyWndPane  *itsPane;	
	Box	 			 itsKeyRec;
	
	
	void		IFingKeyWndDesc (CFingKeyWndPane *pane, Box key);
	
	void		BeginTracking (LongPt *startPt);
	void		KeepTracking  (LongPt *currPt, LongPt *prevPt, LongPt *startPt);

};