/****
 * CSymWndBox.c
 *
 *	Symbol window box methods for the SignWriter key editor.
 *
 *  Copyright  1995 The Center for Sutton Movement Writing.  All rights reserved.
 *
 ****/


#include "CSymWndBox.h"
#include "KeyEditConsts.h"
#include <CPane.h>
#include <BDC.h>


void CSymWndBox::ISymWndBox(CView *anEnclosure, CBureaucrat *aSupervisor,
								short aWidth, short aHeight,
								short aHEncl, short aVEncl,
								SizingOption aHSizing, SizingOption aVSizing)
{
	itsSymCode = -1;
	
	inherited::IPane(anEnclosure, aSupervisor, aWidth, aHeight,
					aHEncl, aVEncl, aHSizing, aVSizing);
}

							

/***
 * Draw
 *
 *	Refresh current symcode display.
 *
 ***/

void CSymWndBox::Draw(Rect *area)

{
	Update(itsSymCode);
}



/***
 * Update
 *
 *	Draw the value of the specified symbol in the
 *	file window's current symbol code box.  If the
 *	code value is less than 0, erase the box contents.
 *
 ***/

void CSymWndBox::Update(short symCode)

{
	Str15	str;
	Rect	rect;

	itsSymCode = symCode;
	
	Prepare();
	SetRect(&rect, 0, 1, SBOX_WIDTH, SBOX_HEIGHT); 
	EraseRect(&rect);

	if (symCode >= 0) {
		NumToString(symCode,str);
		TextFont(1); TextFace(0); TextSize(10);
		MoveTo((SBOX_WIDTH - StringWidth(str)) / 2, SBOX_HEIGHT - 2);
		DrawString(str);
	}	
}



/***
 * Dispose
 *
 *	Pass the buck.
 *
 ***/

void CSymWndBox::Dispose(void)

{
	inherited::Dispose();
}


