/****
 * CKeyWndKeys.h
 *
 *	Key window key class for SignWriter.
 *
 *  Copyright  1996 The Center for Sutton Movement Writing.  All rights reserved.
 *
 ****/

#pragma	once					/* Include only once */



#include "CGridSelector.h"
#include "Keys.h"




struct CKeyWndKeys : CGridSelector {

	
				/* Pane keys */
	Byte		*itsKeyCodes;


				/* Pane state */
	KbdType		itsCurKbd;
	
	
				/* Pane list */
	CKeyWndKeys *itsNextPane;
	
	
				/* Initialization */
	void		IKeyWndKeys (CView *anEnclosure, CBureaucrat *aSupervisor,
							  short aHEncl, short aVEncl,
							  short numKeys, Byte keyCodes[],
							  short paneCmd, CKeyWndKeys *nextKeyPane);
	
	
				/* Key mapping */
	Byte 		ItemToKeyCode  (short item);
    char 		ItemToCharCode (short item);
    char 		KeyToCharCode  (short keyCode);

	unsigned char  *KeyName (long theCommand);
	
	
				/* Drawing */
	void		DrawItem  (short theItem, Rect *theBox);
	void		UpdateKey (Byte keyCode);
	void		Update    (KbdType theKbd);


				/* Selection */
	void		UpdateSelect (long command);

	
				/* Clipboard */
	void		GetKey   (Byte keyCode, void **rec);
	void		SetKey   (Byte keyCode, void *rec);
	void		CopyKey  (void *rec, void **copyRec);
	void 		ClearKey (void **rec);
	void		GetKeyType (ObjType *type);

	
				/* Commands */
	void		DoCopy  (void);
	void		DoPaste (void);
	void		DoClear (short taskIndex);
	void		DoKeyCommand (Byte keyCode);

	
				/* Mouse */
	void		DoDoubleClick (void);
	

				/* Window management */
	void		GetSignKeyWindow   (short keyCode, void **wind);						  
	void		SetSignKeyWindow   (short keyCode, void *wind);
	void		GetFingerKeyWindow (short keyCode, void **wind);						  
	void		SetFingerKeyWindow (short keyCode, void *wind);	
	Boolean		KeyWindowsOpen (void);
	
	
				/* Key box editing */
	void		OpenKeyWindow      (Byte keyCode, char keyName);
	void		NewSignKeyWindow   (Byte keyCode, char keyName);
	void		NewFingerKeyWindow (Byte keyCode, char keyName);

};
