
/****
 * SignWriterConsts.h
 *
 *	Global constants for SignWriter.
 *
 ****/


#pragma once


/* Keyboard types */
		
typedef enum {sign = 1, fingerspelling = 2} KbdType;



/* Key edit object types */
		
typedef enum {key, box, sym, none} ObjType;



/* Key edit bitmap */

#define IMG_MAP			288		/* 48x48  image bitmap  */



/* Selection states */

#define	SELnone			0		/* No grid cell selected */



/* Thumbnail views */

#define	THUMB_SCALE		 2		/* Thumbnail scale reduction  */


 
/* Update sign keyboard dialog button name */	
							
#define	UPDATE_NAME		"Update"

 
 
/* Symbol file name	*/

#define SYMFILE_NAME	"SignWriter symbols"


 
 
/* Symbol window */

#define	SWND_RSRC		500		/* Resource ID for sym window */

#define	SWND_HEIGHT		289		/* Standard height of sym window */
#define	SWND_MINWIDTH	119		/* Minimum width of sym window   */
#define	SWND_MAXWIDTH	524		/* Maximum width of sym window   */

#define	SGRID_COLS		100		/* Sym window symbol grid columns  */
#define	SGRID_ROWS		11		/* Sym window symbol grid rows	   */
#define	SGRID_SYMS		1000	/* Sym window symbol grid symbols  */

#define	SCELL_WIDTH		25		/* Sym window symbol cell width  */
#define	SCELL_HEIGHT	25		/* Sym window symbol cell height */

#define	SBOX_HEIGHT		13		/* Sym window symcode box height */
#define	SBOX_WIDTH		36		/* Sym window symcode box width  */

								/* Sym window title	*/								
#define	SWND_TITLE		"Symbols"




/* File window */

#define	FWND_RSRC		501		/* Resource ID for file window */

#define	FWND_HEIGHT		142		/* Height of file window */
#define	FWND_WIDTH		340		/* Width of file window  */

#define	FCELL_WIDTH		25		/* Key pane cell width  */
#define	FCELL_HEIGHT	25		/* Key pane cell height */
								
								
								/* Vert. offsets of key panes */
#define	FKEY1_TOP		15	
#define	FKEY2_TOP		FKEY1_TOP + FCELL_WIDTH
#define	FKEY3_TOP		FKEY2_TOP + FCELL_WIDTH
#define	FKEY4_TOP		FKEY3_TOP + FCELL_WIDTH

								/* Horiz. offsets of key panes */
#define	FKEY1_LEFT		15	
#define	FKEY2_LEFT		FKEY1_LEFT + (FCELL_WIDTH / 2)
#define	FKEY3_LEFT		FKEY2_LEFT + (FCELL_WIDTH / 2)
#define	FKEY4_LEFT		FKEY3_LEFT + (FCELL_WIDTH / 2)


#define	FBOX_HEIGHT		14		/* Box pane height */

#define	FBOX1_WIDTH		40		/* Cur key box pane width 	  */
#define FBOX2_WIDTH		300		/* Cur key box pane width 	  */

								/* Cur key box pane init      */
#define	FBOX1_INIT		"A"

								/* Cur keyboard pane labels   */
#define	FBOX2_SIGN		"Sign"				
#define	FBOX2_FINGER	"Fingerspelling"
	


		 
/* Sign key window */

#define	SKWND_TOP		360		/* Top of sign key window 	 */
#define	SKWND_LEFT		10		/* Left of sign key window   */

#define	SKWND_HEIGHT	48		/* Height of sign key window  */
#define	SKWND_WIDTH		587		/* Width of sign key window   */

#define	SKGRID_COLS		12		/* Sym window symbol grid columns  */
#define	SKGRID_ROWS		1		/* Sym window symbol grid rows	   */

#define	SKCELL_WIDTH	49		/* Key pane cell width  */
#define	SKCELL_HEIGHT	49		/* Key pane cell height */


		 
/* Fingerspell key window */

#define	FKWND_TOP		360		/* Top of fingerspell key window 	 */
#define	FKWND_LEFT		18		/* Left of fingerspell key window    */

#define	FKWND_HEIGHT	72		/* Height of fingerspell key window  */
#define	FKWND_WIDTH		72		/* Width of fingerspell key window   */

#define	FKPANE_TOP		12		/* Top of fingerspell key pane   */
#define	FKPANE_LEFT		12		/* Left of fingerspell key pane  */

#define	FKPANE_WIDTH	48		/* Fingerspell key pane width	  */
#define	FKPANE_HEIGHT	48		/* Fingerspell key pane height	  */




/* Key window cursor */

#define	KCURS_TOP		18		/* Top of key window cursor	   */
#define	KCURS_LEFT		24		/* Left of key window cursor   */
#define	KCURS_LEN		12		/* Length of key window cursor */




/* Selection blinking */

#define SYM_ON			7		/* Ticks symbol on  */
#define SYM_OFF  		1		/* Ticks symbol off */




/* Resources */

#define	ALRTgeneral		128		/* Resource ID for vanilla           alert box */
#define	ALRTnoSymFile	152		/* Resource ID for missing symfile   alert box */
#define	ALRTkeyFull		153		/* Resource ID for key full			 alert box */

#define	ALRTnoSymbol	157		/* Resource ID for empty symbol  	 alert box */
#define	ALRTopenKeys	158		/* Resource ID for open key windows  alert box */
#define	ALRTaboutApp	160		/* Resource ID for about appl		 alert box */
#define	ALRTnoRoom		161		/* Resource ID for no room			 alert box */




/* Menu commands */

#define	cmdUpdateSignKbd 1026L	/* Command value for Update Sign Keyboard cmd */

#define	cmdAdd    		 1028L	/* Command value for Add    cmd 	*/
#define	cmdFill		 	 1029L	/* Command value for Fill   cmd 	*/
#define	cmdCursor		 1030L	/* Command value for Cursor cmd 	*/
#define	cmdMirror		 1031L	/* Command value for Mirror cmd 	*/
#define	cmdChange		 1032L	/* Command value for Change cmd 	*/
#define	cmdRotate		 1033L	/* Command value for Rotate cmd 	*/

#define	cmdKbd				  1034L	  /* Command value for Keyboard cmd */
#define	cmdKbdSign			  1035L	  /* Command value for Keyboard cmd */
#define	cmdKbdFingerspelling  1036L	  /* Command value for Keyboard cmd */




/* Mouse commands */

#define cmdSelectCell	1039L	/* Command value for sym pane   cell click    */

#define cmdSelectCell1	1040L	/* Command value for key pane 1 cell click    */
#define cmdSelectCell2	1041L	/* Command value for key pane 2 cell click    */
#define cmdSelectCell3	1042L	/* Command value for key pane 3 cell click    */
#define cmdSelectCell4	1043L	/* Command value for key pane 4 cell click    */




/* Key commands */

#define	SHFT_KEY		0x38	/* Hardware code for shift key	*/




/* Alert results */

#define OK				1		/* Result value for 'OK' button     */
#define Cancel			2		/* Result value for 'Cancel' button */




/* Task commands */

#define		iADD			1	/* Index of Add task name 		*/
#define		iCUT			2	/* Index of Cut task name 		*/
#define		iCLEAR			5	/* Index of Clear task name 	*/
#define		iPASTE			4	/* Index of Paste task name 	*/
