/******************************************************************************
 Symbols.h

		Symbol data manager interface for the SignWriter symbol editor
		
		Copyright  1995 Center for Sutton Movement Writing. All rights reserved.

 ******************************************************************************/
 
#pragma once



#include "LongCoordinates.h"



		// Symbol types
		
typedef enum {face, hand, movement, shoulder, contact, other} SymbolType;



		// Image classes
		
typedef enum {class1, class2, class3A, class3B, class4, class5} ImageClass;



	   // Status
	  
Boolean  SymEmpty (short symCode);



	  // Initialization
	  
void  NewSymbol (short symCode);

void  ISymbol (short symCode);

void  DisposSymbol (short symCode);



	  // Symbol type
	  
void  GetSymType (SymbolType *symType);


				 
	  // Fill variations
	  
void  GetFillVars (short *numFills);



	  // Image class
	  
void  GetClass (ImageClass *imgClass);



	  // Image rotations
	  
void  GetRotations (short *numRots);
				   
				   

	  // Image flops
	  
void  GetFlops (short *numFlops);
					
				   
			
	  // Images
	  	   
void  GetImages (ImageClass imgClass, short *numImgs);

			
							 
	  // Symbol editing				 				  

void  GetSymbolRec (short symCode,
				 	void **symbolRec);
				  
void  SetSymbolRec (short symCode,
				 	void *symbolRec);			

void  CopySymbolRec (void *symbolRec,
				  	 void **copyRec);

// no ClearSymbolRec!
				  	 			  	 		  
void  DisposSymbolRec (void *symbolRec);
			
			
				 
	  // Sym variation editing				 				  

void  GetSymVarRec (short symCode, short symVar,
				 	void **symVarRec);
				  
void  SetSymVarRec (short symCode, short symVar,
				 	void *symVarRec);			

void  CopySymVarRec (void *symVarRec,
				 	 void **copyRec);
				 	 
void  ClearSymVarRec (void **symVarRec);				 	
			  
void  DisposSymVarRec (void *symVarRec);				 	
				 	
				 	
				 	
	  // Fill variation editing				 				  
	 	
void  GetFillVarRec (short symCode, short symVar, short fillVar,
				 	 void **fillVarRec);
				  
void  SetFillVarRec (short symCode, short symVar, short fillVar,
				 	 void *fillVarRec);			

void  CopyFillVarRec (void *fillVarRec,
				 	  void **copyRec);

void  ClearFillVarRec (void **fillVarRec);
				  
void  DisposFillVarRec (void *fillVarRec);



 	  // Image editing				 				  

void  GetImageRec (short symCode, short symVar, short fillVar, short image,
				   void **imageRec);
				  
void  SetImageRec (short symCode, short symVar, short fillVar, short image,
				   void *imageRec);
	
void  CopyImageRec (void *imageRec,
				 	void **copyRec);

void  ClearImageRec (void **imageRec);
			   				  
void  DisposImageRec (void *imageRec);



	  // File I/O support
	  
void  PackSymbol (short symCode, Handle symBuf, unsigned short *symBytes);

void  UnpackSymbol (short symCode, Handle symBuf, short symBytes, short symAttrs);

	  
			   