
/******************************************************************************
 CFileWndTask.h

  Interfaces for the FileWndTask Classes
		
  Copyright 1995 The Center for Sutton Movement Writing. All rights reserved.
		
 ******************************************************************************/
 
 
#pragma once


#include "CTask.h"						/* Interface for its superclass		*/
#include "CFileWndGrid.h"



struct CFileWndClear : CTask {	

	CFileWndGrid *itsGridPane;	
	
	short		itsSelect;
	short		itsSymCode;

	void		IFileWndClear (short nameIndex, CFileWndGrid *pane, short select);
	
	void		Do   (void);
	void		Undo (void);
	void		Redo (void);
};



struct CFileWndPaste : CTask {	
	
	CFileWndGrid *itsGridPane;	
	
	short		itsSelect;
	short		itsSymCode;
	
	void		IFileWndPaste (CFileWndGrid *pane, short select);
	
	void		Do   (void);
	void		Undo (void);
	void		Redo (void);
};



struct CFileWndInsert : CTask {	
	
	CFileWndGrid *itsGridPane;	
	
	short		itsSelect;
	short		itsSymCode;
	
	void		IFileWndInsert (CFileWndGrid *pane, short select);
	
	void		Do   (void);
	void		Undo (void);
	void		Redo (void);
};



struct CFileWndDelete : CTask {	
	
	CFileWndGrid *itsGridPane;	
	
	short		itsSelect;
	short		itsSymCode;
	
	void		IFileWndDelete (CFileWndGrid *pane, short select);
	
	void		Do   (void);
	void		Undo (void);
	void		Redo (void);
};