/****
 * CImgWindow.h
 *
 *	Image window class for the SignWriter symbol editor.
 *
 *  Copyright  1995 The Center for Sutton Movement Writing.  All rights reserved.
 *
 ****/

#pragma once	


#include "CDirector.h"
#include "CImgWndPane.h"
#include "CSymWndGrid.h"


 

struct CImgWindow : CDirector {


				/* Panes */
	CImgWndPane	*itsEditPane;
	CSymWndGrid *itsSymWind;
	

				/* Initialization */
	void        IImgWindow (CDirectorOwner *aSupervisor);
    void        Dispose (void);

	
				/* Commands */
	void		DoCommand (long theCommand);

 
 				/* Menus */
    void        UpdateMenus (void);  

				
				/* Windows */
	void		NewWindow (short symCode, short symVar, short fillVar, short image,
						   CSymWndGrid *symWind);
						   
	Boolean		Close (Boolean quitting);

};