/******************************************************************************
 CImgWndToolEdit.h

		Interface for the ToolEdit Class
		
		Also contains classes for the individual edit tools:
			Eraser, Pencil, and Dragger
		
    	Copyright  1995 The Center for Sutton Movement Writing.  All rights reserved.
		
 ******************************************************************************/
 
#pragma once

#include "CImgWndTask.h"				/* Interface for its superclass		*/
#include "CImgWndPane.h"

struct CToolEdit : CImgWndTask {


	short		penLength;
	LongRect	dirtyRect;


	void		BeginTracking (LongPt *startPt);
	void		KeepTracking  (LongPt *currPt, LongPt *prevPt, LongPt *startPt);
	void		EndTracking   (LongPt *currPt, LongPt *prevPt, LongPt *startPt);

	void		CalcPenRect   (LongPt *thePt, LongRect *penRect);
	void		CalcDirtyRect (LongRect *penRect);
	void		CalcDrawRgn   (LongRect *currRect, LongRect *prevRect, RgnHandle drawRgn);
	
	void		UseTool (LongPt *currPt, LongPt *prevPt);
};


					/*** Classes for the Individual Tools ***/

struct CToolEraser : CToolEdit {
	void		IToolEraser   (CImgWndPane *aPane, CBitMap *aBitMap);
	void		BeginTracking (LongPt *startPt);
	void		UseTool       (LongPt *currPt, LongPt *prevPt);
};


struct CToolPencil : CToolEdit {
	void		IToolPencil   (CImgWndPane *aPane, CBitMap *aBitMap);
	void		BeginTracking (LongPt *startPt);
	void		UseTool       (LongPt *currPt, LongPt *prevPt);
};


struct CToolDrag : CToolEdit {
	LongPt		saveCenter;
	void		IToolDrag     (CImgWndPane *aPane, CBitMap *aBitMap);
	void		BeginTracking (LongPt *startPt);
	void		UseTool       (LongPt *currPt, LongPt *prevPt);
	void		EndTracking   (LongPt *currPt, LongPt *prevPt, LongPt *startPt);
	void		Undo		  (void);
};