/****
 * CProgWindow.c
 *
 *	Document methods for the progress window.
 *
 *  Copyright  1995 The Center for Sutton Movement Writing.  All rights reserved.
 *
 ****/
 


#include "CProgWindow.h"
#include "CDesktop.h"
#include "CDirector.h"
#include "CPane.h"
#include "CWindow.h"
#include "LongQD.h"
#include "SymEditConsts.h"





/*** Global Variables ***/

extern	CDesktop	 *gDesktop;		/* The enclosure for all windows */




/*** Constants ***/

#define	PROG_INCR	5				/* Progress window increment amount */




/***
 *  IProgressWindow
 *
 ***/

void CProgressWindow::IProgressWindow (CDirector *aSupervisor, short total)

{
	LongRect	frame;
	
	IWindow(PWND_RSRC, FALSE, gDesktop, aSupervisor);
	GetInterior(&frame);

	itsPane = new CProgressPane;
 	itsPane->IPane(this, aSupervisor,
    			   frame.right, frame.bottom, 
    			   0, 0,
    			   sizFIXEDLEFT, sizFIXEDTOP);   						
	
	itsCount = 0;
	itsTotal = total;

}
	


/***
 * ShowProgress
 *
 ***/

void CProgressWindow::ShowProgress (void)

{
	itsPane->UpdatePane(&itsCount, itsTotal);
}



/***
 * UpdatePane
 *
 ***/

void CProgressPane::UpdatePane (short *count, short total)

{
	LongRect	rect;
	float		boxFract;
	
	if (((*count)++ % PROG_INCR) == 0) {
	
		Prepare();
		GetFrame(&rect);
		
		boxFract = *count;
		rect.right *= boxFract / total;
		
		PenPat(gray);
		LPaintRect(&rect);
	}
}


