/******************************************************************************
 CToolPens.h

		Interface for the ToolPens Class
		
		Also contains classes for the individual pen-like tools:
			Eraser, Pencil, and Paint Brush
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
 ******************************************************************************/
 
#define _H_CToolPens

#include "CPaintTask.h"					/* Interface for its superclass		*/
#include "CPaintPane.h"

struct CToolPens : CPaintTask {			/* Class Declaration				*/
								/** Instance Variables **/
	short		penLength;
	LongRect		dirtyRect;

								/** Instance Methods **/
	void		BeginTracking(LongPt *startPt);
	void		KeepTracking(LongPt *currPt, LongPt *prevPt, LongPt *startPt);
	void		CalcPenRect(LongPt *thePt, LongRect *penRect);
	void		CalcDirtyRect(LongRect *penRect);
	void		CalcDrawRgn(LongRect *currRect, LongRect *prevRect, RgnHandle drawRgn);
	void		EndTracking(LongPt *currPt, LongPt *prevPt, LongPt *startPt);
	void		UseTool(LongPt *currPt, LongPt *prevPt);
};


					/*** Classes for the Individual Tools ***/

struct CToolEraser : CToolPens {		/* Eraser							*/
	void		IToolEraser(CPaintPane *aPaintPane, CBitMap *aPainting);
	void		BeginTracking(LongPt *startPt);
	void		UseTool(LongPt *currPt, LongPt *prevPt);
};

struct CToolPencil : CToolPens {		/* Pencil							*/
	void		IToolPencil(CPaintPane *aPaintPane, CBitMap *aPainting);
	void		BeginTracking(LongPt *startPt);
	void		UseTool(LongPt *currPt, LongPt *prevPt);
};

struct CToolBrush : CToolPens {			/* Paint Brush						*/
	void		IToolBrush(CPaintPane *aPaintPane, CBitMap *aPainting);
	void		BeginTracking(LongPt *startPt);
	void		UseTool(LongPt *currPt, LongPt *prevPt);
};