/******************************************************************************
 CToolsDir.c

							The ToolsDir Class
	
		Director for the Tools tear-off menu

	SUPERCLASS = CTearOffMenu
	
	Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/

#include <Global.h>
#include <CCharGrid.h>
#include <CSelectorMDEF.h>
#include "CToolsDir.h"
#include "ArtClassCmds.h"
#include "CWindow.h"

/*** Global Variables ***/

extern CBureaucrat	*gGopher;			/* First in line to get commands	*/

extern short		gPaintTool;			/* The current painting tool		*/

/*** Class Contstants ***/

#define		WINDtools		1003		/* Resource ID for tools window		*/


/******************************************************************************
 IToolsDir

		Initialize a ToolsDir object
 ******************************************************************************/

void	CToolsDir::IToolsDir(
    CApplication        *aSupervisor)
{
	CCharGrid		*theTools;
	CSelectorMDEF	*theSelectorMDEF;
	short			width;
	short			height;
	Rect			sizeRect;

	CTearOffMenu::ITearOffMenu(aSupervisor, WINDtools);

	itsWindow->SetActClick(TRUE);
							
	theTools = new(CCharGrid);
	theTools->ICharGrid(MENUtools, itsWindow, this);
	theTools->Activate();
	
	theTools->selection = gPaintTool;

										/* Make window same size as Tools	*/
										/*   without lines on the edges		*/
	theTools->GetLengths(&width, &height);
	SetRect(&sizeRect, width-1, height-1, width, height);
	itsWindow->SetSizeRect(&sizeRect);
	itsWindow->ChangeSize(width-1, height-1);
	
	itsPane = theTools;
	SetRect(&margins, 1, 10, 1, 1);		/* One pixel frame with a 10 pixel	*/
										/*   drag bar on the top side		*/

	theSelectorMDEF = new(CSelectorMDEF);
	theSelectorMDEF->ISelectorMDEF(MENUtools, itsPane, this);
	
	itsWindow->MoveOffScreen();			/* Put window out of sight until	*/
	itsWindow->Select();				/*   needed							*/
}
	

/******************************************************************************
 DoCommand {OVERRIDE}

		Handle commands for the selection of a tool
 ******************************************************************************/

void	CToolsDir::DoCommand(
	long		theCommand)
{
	Str255			commandStr;

	if (HiShort(-theCommand) == ((CCharGrid*)itsPane)->GetCommandBase()) {
										/* Item from Tools was selected		*/
		gGopher->DoCommand(theCommand);								
	
	} else {
		inherited::DoCommand(theCommand);
	}
}
	

/******************************************************************************
 SelectTool

		Set the current tool selection
 ******************************************************************************/

void	CToolsDir::SelectTool(
	short		theTool)
{
	itsPane->Prepare();
	((CCharGrid*)itsPane)->ChangeSelection(theTool);
}