
/*
 *  perror.c
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#include "stdio.h"
#include "string.h"
#include "errno.h"
#include "ansi_private.h"

static void error(FILE *, int);


void
perror(const char *s)
{
	int i = errno;
	
	if (s && *s)
		fprintf(stderr, "%s: ", s);
	error(stderr, i);
	fputc('\n', stderr);
}


char *
strerror(int i)
{
	FILE f;
	static char buf[20];
	
	error(__strout(&f, buf), i);
	return(buf);
}


static void
error(FILE *fp, int i)
{
	fprintf(fp, "Error %d", i);
}
