
/*
 *  signal.c
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#include "signal.h"
#include "errno.h"
#include "stdlib.h"


static __sig_func sig[__NSIG+1];


__sig_func
signal(int i, __sig_func f)
{
	__sig_func oldf;
	
	if (i <= 0 || i > __NSIG) {
		errno = EINVAL;
		return(SIG_ERR);
	}
	oldf = sig[i];
	sig[i] = f;
	return(oldf);
}


int
raise(int i)
{
	__sig_func f;
	
	if (i <= 0 || i > __NSIG) {
		errno = EINVAL;
		return(-1);
	}
	f = sig[i];
	if (f != SIG_IGN) {
		sig[i] = SIG_DFL;
		if (f == SIG_DFL)
			_exit(0);
		(*f)(i);
	}
	return(0);
}


void
abort(void)
{
	raise(SIGABRT);
	_exit(0);
}
