
/*
 *  str.c
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#pragma options(!require_protos)

#include "size_t.h"


char *
strcpy(/* char *s1, const char *s2 */)
{
	asm {
		movea.l	4(sp),a0		;  A0 = s1
		movea.l	8(sp),a1		;  A1 = s2
		move.l	a0,d0			;  D0.L = result
@1		move.b	(a1)+,(a0)+
		bne.s	@1
	}
}


char *
strcat(/* char *s1, const char *s2 */)
{
	asm {
		movea.l	4(sp),a0		;  A0 = s1
		movea.l	8(sp),a1		;  A1 = s2
		move.l	a0,d0			;  D0.L = result
@1		tst.b	(a0)+
		bne.s	@1
		subq.l	#1,a0
@2		move.b	(a1)+,(a0)+
		bne.s	@2
	}
}


int
strcmp(/* const char *s1, const char *s2 */)
{
	asm {
		movea.l	4(sp),a0		;  A0 = s1
		movea.l	8(sp),a1		;  A1 = s2
		moveq	#0,d0			;  D0.L = result
		bra.s	@2
@1		tst.b	d1
		beq.s	@4
@2		move.b	(a0)+,d1
		cmp.b	(a1)+,d1
		beq.s	@1
		bhi.s	@3
		subq.l	#2,d0
@3		addq.l	#1,d0
@4	}
}


char *
strchr(/* const char *s, int c */)
{
	asm {
		movea.l	4(sp),a0		;  A0 = s
#if __option(int_4)
		move.b	11(sp),d1		;  D1.B = (char) c
#else
		move.b	9(sp),d1		;  D1.B = (char) c
#endif
		moveq	#0,d0			;  D0.L = result
		bra.s	@2
@1		tst.b	(a0)+
		beq.s	@3
@2		cmp.b	(a0),d1
		bne.s	@1
		move.l	a0,d0
@3	}
}


size_t
strcspn(/* const char *s1, const char *s2 */)
{
	asm {
		movea.l	4(sp),a0		;  A0 = s1
		moveq	#-1,d0			;  D0.L = result
@1		addq.l	#1,d0
		move.b	(a0)+,d1
		beq.s	@3
		movea.l	8(sp),a1		;  A1 = s2
@2		move.b	(a1)+,d2
		beq.s	@1
		cmp.b	d1,d2
		bne.s	@2
@3	}
}


char *
strpbrk(/* const char *s1, const char *s2 */)
{
	asm {
		movea.l	4(sp),a0		;  A0 = s1
		moveq	#0,d0			;  D0.L = result
@1		move.b	(a0)+,d1
		beq.s	@3
		movea.l	8(sp),a1		;  A1 = s2
@2		move.b	(a1)+,d2
		beq.s	@1
		cmp.b	d1,d2
		bne.s	@2
		subq.l	#1,a0
		move.l	a0,d0
@3	}
}


char *
strrchr(/* const char *s, int c */)
{
	asm {
		movea.l	4(sp),a0		;  A0 = s
#if __option(int_4)
		move.b	11(sp),d1		;  D1.B = (char) c
#else
		move.b	9(sp),d1		;  D1.B = (char) c
#endif
		moveq	#0,d0			;  D0.L = result
@1		cmp.b	(a0),d1
		bne.s	@2
		move.l	a0,d0
@2		tst.b	(a0)+
		bne.s	@1
	}
}


size_t
strspn(/* const char *s1, const char *s2 */)
{
	asm {
		movea.l	4(sp),a0		;  A0 = s1
		moveq	#0,d0			;  D0.L = result
		bra.s	@2
@1		cmp.b	d1,d2
		bne.s	@3
		addq.l	#1,d0
@2		move.b	(a0)+,d1
		beq.s	@4
		movea.l	8(sp),a1		;  A1 = s2
@3		move.b	(a1)+,d2
		bne.s	@1
@4	}
}


char *
strstr(/* const char *s1, const char *s2 */)
{
	asm {
		move.l	4(sp),d0		;  D0.L = result
		bra.s	@2
@1		cmp.b	d1,d2
		beq.s	@3
		addq.l	#1,d0
@2		movea.l	d0,a0			;  A0 = s1
		movea.l	8(sp),a1		;  A1 = s2
@3		move.b	(a1)+,d1
		beq.s	@4
		move.b	(a0)+,d2
		bne.s	@1
		moveq	#0,d0
@4	}
}


char *
strtok(/* char *s1, const char *s2 */)
{
	static char *next;
	
	asm {
		move.l	4(sp),d0		;  D0.L = result
		bne.s	@2
@1		move.l	next,d0
		beq.s	@8
@2		clr.l	next
	}

		/*  find start of token  */
		
	asm {
		movea.l	d0,a0			;  A0 = s1
		bra.s	@4
@3		cmp.b	d1,d2
		bne.s	@5
		move.l	a0,d0
@4		move.b	(a0)+,d1
		beq.s	@1
		movea.l	8(sp),a1		;  A1 = s2
@5		move.b	(a1)+,d2
		bne.s	@3
	}
	
		/*  find end of token  */
		
	asm {	
@6		move.b	(a0)+,d1
		beq.s	@8
		movea.l	8(sp),a1		;  A1 = s2
@7		move.b	(a1)+,d2
		beq.s	@6
		cmp.b	d1,d2
		bne.s	@7
		move.l	a0,next
		clr.b	-(a0)
@8	}
}


size_t
strlen(/* const char *s */)
{
	asm {
		moveq	#-1,d0			;  D0.L = result
		movea.l	4(sp),a0		;  A0 = s
@1		addq.l	#1,d0
		tst.b	(a0)+
		bne.s	@1
	}
}
