
/*
 *  SANE.h
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 *
 */

#include <SANE.h>


void
x80tox96(...)
{
	asm {
		movea.l	4(sp),a0
		movea.l	8(sp),a1
		move.l	6(a0),8(a1)
		move.l	2(a0),4(a1)
		move.w	(a0),(a1)
		move.w	(a1)+,(a1)
	}
}


void
x96tox80(...)
{
	asm {
		movea.l	4(sp),a0
		movea.l	8(sp),a1
		move.w	(a0),(a1)
		move.l	4(a0),2(a1)
		move.l	8(a0),6(a1)
	}
}


void
num2dec(const decform *f, extended x, decimal *d)
{
	fp68k(f, &x, d, FX2DEC);
}


extended
dec2num(const decimal *d)
{
	extended x;
	
	fp68k(d, &x, FDEC2X);
	return(x);
}


void
str2dec(const void *s, short *n, decimal *d, Boolean *p)
{
	decstr68k(s, n, d, p, FPSTR2DEC);
}


void
cstr2dec(const void *s, short *n, decimal *d, Boolean *p)
{
	decstr68k(s, n, d, p, FCSTR2DEC);
}


void
dec2str(const decform *f, const decimal *d, void *s)
{
	decstr68k(f, d, s, FDEC2STR);
}


extended
str2num(void *s)
{
	short n = 1;
	char p = 0;
	decimal d;
	extended x;
	
	decstr68k(s, &n, &d, &p, FPSTR2DEC);
	fp68k(&d, &x, FDEC2X);
	return(x);
}


void
num2str(decform *f, extended x, void *s)
{
	decimal d;
	
	fp68k(f, &x, &d, FX2DEC);
	decstr68k(f, &d, s, FDEC2STR);
}
