
/*
 *  SANE.h
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 *
 */

#include <SANE.h>


extended __inf = { 0x7FFF };
extended __pi = { 0x4000, 0xC90F, 0xDAA2, 0x2168, 0xC235 };


extended
annuity(extended r, extended n)
{
	extended z;
	
	elems68k(&r, &n, &z, FANNUITY);
	return(z);
}


extended
compound(extended r, extended n)
{
	extended z;
	
	elems68k(&r, &n, &z, FCOMPOUND);
	return(z);
}


extended
ipower(extended x, short i)
{
	elems68k(&i, &x, FXPWRI);
	return(x);
}


extended
power(extended x, extended y)
{
	elems68k(&y, &x, FXPWRY);
	return(x);
}


extended
randomx(extended *x)
{
	elems68k(x, FRANDX);
	return(*x);
}


extended
remainder(extended x, extended y, short *q)
{
	fp68k(&y, &x, FREMX);
	asm {
		movea.l	q,a0
		move.w	d0,(a0)
	}
	return(x);
}


extended
scalb(short n, extended x)
{
	fp68k(&n, &x, FSCALBX);
	return(x);
}


extended
nan(short code)
{
	asm {
		move.w	code,d0
		bne.s	@1
		moveq	#NANZERO,d0
@1		addi.w	#0x4000,d0
	}
	asm {
		movea.l	8(a6),a0
		move.w	#0x7FFF,(a0)+
		move.w	d0,(a0)+
		clr.l	(a0)+
		clr.w	(a0)+
	}
}


extended
_fp1(short op, extended x)
{
	fp68k(&x, op);
	return(x);
}


extended
_elems1(short op, extended x)
{
	elems68k(&x, op);
	return(x);
}
