/******************************************************************************
 CColorWindow.c

							The ColorWindow Class
	
	SUPERCLASS = CWindow
	
	Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/

#include "Global.h"
#include "CColorWindow.h"


/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/


/******************************************************************************
 IColorWindow

		Initialize a ColorWindow object. Same as IWindow.
 ******************************************************************************/

void	CColorWindow::IColorWindow(
	short			WINDid,				/* Window resource ID				*/
	Boolean			aFloating,			/* Is this a floating window?		*/
	struct CDesktop		*anEnclosure,		/* Enclosing display of the window	*/
	struct CDirector	*aSupervisor)		/* Supervisor in chain of command	*/
{
	inherited::IWindow(WINDid, aFloating, anEnclosure, aSupervisor);
}
	

/******************************************************************************
 MakeMacWindow

		Create a new Toolbox COLOR window record using the specified WIND
		resource ID. 
 ******************************************************************************/

void	CColorWindow::MakeMacWindow(
	short		WINDid)					/* Window resource ID				*/
{
										/* Create a new Mac color window	*/
										/*   Floating windows are put in	*/
										/*   front of all others, regulars	*/
										/*   are put behind all others		*/
	macPort = GetNewCWindow(WINDid, NULL, (floating ? (WindowPtr)(-1L) : NULL));
}
