/******************************************************************************
 OCluster.h

		Interface for the Cluster Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/
 
#define _H_OCluster

#include "CCollection.h"				/* Interface for its superclass		*/
#include "Global.h"

struct OCluster : CCollection {			/* Class Declaration				*/
								/** Instance Variables **/
	short		blockSize;				/* Number of slots to allocate when */
										/*  more space is needed			*/
	short		slots;					/* Total number of slots allocated	*/
	LongHandle	items;					/* Items in the cluster				*/
	
								/** Instance Methods **/
	void		ICluster(void);			/* Initialization					*/
	void		Dispose(void);			/* Dispose of a Cluster				*/	
	void		DisposeAll(void);		/* Dispose of Cluster and all items	*/
	void		DisposeItems(void);		/* Dispose of all items in Cluster	*/

										/* Specify a new blockSize			*/
	void		SetBlockSize(short aBlockSize);
										/* Add an object to the cluster		*/
	void		Add(CObject *theObject);
										/* Remove an object					*/
	void		Remove(CObject *theObject);
										/* Test for inclusion of an object	*/
	Boolean		Includes(CObject *theObject);
	void		DoForEach(VoidFunc);	/* Call a function for each item in	*/
										/*   the cluster					*/
	void		DoForEach1(VoidFunc, long);
	CObject*	FindItem(BooleanFunc);
	CObject*	FindItem1(BooleanFunc, long param);
										/* Find offset of object in cluster	*/
	long		Offset(CObject *theObject);
	void		MoreSlots(void);		/* Allocate additional slots		*/
};

#define		SLOT_SIZE		4			/* Byte size of a slot. A slot		*/
										/*   holds a handle to an object.	*/
#define		BAD_INDEX		-1L			/* Flag indicating a failed search	*/