/******************************************************************************
 OList.h

		Interface for the List Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
 ******************************************************************************/
 
#define _H_OList

#include "CCluster.h"					/* Interface for its superclass		*/

struct OList : CCluster {				/* Class Declaration				*/
								/** Instance Variables **/
										/* None								*/
										
								/** Instance Methods **/
	void		IList(void);

	void		Remove(CObject *theObject);
	void		Append(CObject *theObject);
	void		Prepend(CObject *theObject);
	void		InsertAfter(CObject *theObject, CObject *afterObject);
	void		InsertAt(CObject *theObject, long index);
	
	void		BringFront(CObject *theObject);
	void		SendBack(CObject *theObject);
	void		MoveUp(CObject *theObject);
	void		MoveDown(CObject *theObject);
	void		MoveToIndex(CObject *theObject, long index);
	
	CObject*	FirstItem(void);
	CObject*	LastItem(void);
	CObject*	NthItem(long n);
	long		FindIndex(CObject *theObject);
	CObject*	FirstSuccess(BooleanFunc testFunc);
	CObject*	FirstSuccess1(BooleanFunc testFunc, long param);
	CObject*	LastSuccess(BooleanFunc testFunc);
	CObject*	LastSuccess1(BooleanFunc testFunc, long param);
};