/******************************************************************************
 CPopupPane.h

		Interface for the CPopupPane Class
		
		Copyright  1991 Symantec Corporation. All rights reserved.

 ******************************************************************************/

#define _H_CPopupPane

#include "CPane.h"

class CPopupMenu;

class CPopupPane : public CPane
{
public:

	void 	IPopupPane( short menuID, Boolean fAutoSelect, Boolean fMultiSelect,
				CView *anEnclosure, CBureaucrat *aSupervisor,
				short aWidth, short aHeight, short aHEncl, short aVEncl,
				SizingOption aHSizing, SizingOption aVSizing);
				
	virtual void 	IViewTemp( CView *anEnclosure, CBureaucrat *aSupervisor,
							Ptr	viewData);
	virtual void 	Draw( Rect *area);
	
	virtual void 	DoClick( Point hitPt, short modifierKeys, long when);
	
	virtual void 	NewMenuSelection( short itemSelected);
	virtual void 	Activate( void);
	virtual void 	Deactivate( void);
	
	virtual void 	Dispose( void);
	virtual CPopupMenu *GetMenu( void);
	virtual void 	SetMenu( CPopupMenu *aMenu);

protected:

	CPopupMenu *itsMenu;
	
	virtual void MakePopupMenu( short menuID, Boolean fAutoSelect, Boolean fMultiSelect);
	virtual Point CalcPopupPoint( Point hitPt, short modifierKeys, long when);
	virtual long CalcPopupCmd( void);
	
	virtual void ProviderChanged( CCollaborator *aprovider, long reason, void* info);
};

typedef struct		/* CPopupPane template */
{
	PaneTemp	paneTemp;
	short		menuID;
	short		fAutoSelect;
	short		fMultiSelect;
	
} PopupTemp, *PopupTempP;