/******************************************************************************
 CBureaucrat.h

		Interface for the Bureaucrat Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- added BecomeGopher method
		- changed superclass to CCollaborator
		- added override of BroadcastChange, ProviderChanged
		- added DoAppleEvent method
	]

 ******************************************************************************/
 
#define _H_CBureaucrat

#include "CCollaborator.h"			/* Interface for its superclass		*/

class CAppleEvent;
class CTask;

class CBureaucrat : public CCollaborator {			/* Class Declaration				*/

public:
								/** Instance Variables **/
	CBureaucrat		*itsSupervisor;		/* Its boss in the command chain	*/
	
								/** Instance Methods **/
									/** Construction/Destruction **/
	void		IBureaucrat(CBureaucrat *aSupervisor);
	virtual void		Dispose(void);

									/** Accessing **/
	CBureaucrat	*GetSupervisor(void);
	
									/** Commanding **/
	virtual void		Notify(CTask *theTask);
	virtual void		DoKeyDown(char theChar, Byte keyCode, EventRecord *macEvent);
	virtual void		DoAutoKey(char theChar, Byte keyCode, EventRecord *macEvent);
	virtual void		DoKeyUp(char theChar, Byte keyCode, EventRecord *macEvent);
	virtual void		DoCommand(long theCommand);
	virtual void		Dawdle(long *maxSleep);
	virtual void		UpdateMenus(void);
	virtual Boolean		BecomeGopher( Boolean fBecoming);
	virtual void		BroadcastChange( long reason, void* info);
	virtual void		ProviderChanged( CCollaborator *aProvider, long reason, void* info);
	virtual void		DoAppleEvent( CAppleEvent *anAppleEvent);

};

/* Change propagation constants for CBureacrat */

enum
{
			/* bureaucrat has become the gopher, info parameter is zero */
	bureaucratIsGopher = 1,
	
			/* bureaucrat is no longer the gopher, info parameter is zero */
	bureaucratIsNotGopher,
	
	bureaucratLastChange = bureaucratIsNotGopher
};