/******************************************************************************
 CCollaborator.h

		Interface for Collaborator class.
		
	SUPERCLASS = CObject
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#define _H_CCollaborator

#include "CObject.h"

class CList;

class CCollaborator : public CObject
{

public:	
	void ICollaborator( void);
	
	virtual void DependUpon( CCollaborator *aProvider);
	virtual void CancelDependency( CCollaborator *aProvider);

	void Dispose( void);

protected:

	CList *itsProviders;		// the objects a collaborator depends upon
	CList *itsDependents;	// the objects that depend upon it

	virtual void BroadcastChange( long reason, void* info);
	virtual void ProviderChanged( CCollaborator *aProvider, long reason, void* info);

private:	

	virtual void AddDependent( CCollaborator *aDependent);
	virtual void RemoveDependent( CCollaborator *aDependent);
	
	virtual void AddProvider( CCollaborator *aProvider);
	virtual void RemoveProvider( CCollaborator *aProvider);

// Class methods

protected:
	
	static void Dependent_Update( CObject *aDependent, long infoAddr);
	
private:

	static void Dependent_Remove( CObject *aDependent, long aProvider);
	static void Provider_Remove( CObject *aProvider, long aDependent);


};