/******************************************************************************
 CDecorator.h

		Interface for the Decorator Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- added StaggerWindow method
	]
		
 ******************************************************************************/
 
#define _H_CDecorator

#include "CObject.h"					/* Interface for its superclass		*/

class CWindow;

class CDecorator : public CObject {			/* Class Declaration				*/

public:
								/** Instance Variables **/
	short		wCount;					/* Count of number of new windows	*/
	short		index;					/* Index for offsetting windows		*/
	short		wWidth;					/* Width of window in pixels		*/
	short		wHeight;				/* Height of window in pixels		*/
	short		hLocation;				/* Horiz location for next window	*/
	short		vLocation;				/* Vert location for next window	*/

								/** Instance Methods **/
	void		IDecorator(void);
	virtual void		PlaceNewWindow(CWindow *theWindow);
	virtual void		StaggerWindow(CWindow *theWindow);
	virtual void		CenterWindow(CWindow *theWindow);
	virtual short		GetWCount(void);
};