/******************************************************************************
 CDesktop.h

		Interface for the Desktop Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/
 
#define _H_CDesktop

#include "CView.h"						/* Interface for its superclass		*/

	// Forward declarations
	
class CList;
class CWindow;
	
class CDesktop : public CView {				/* Class Declaration				*/

public:
								/** Instance Variables **/
	Rect		bounds;					/* Boundaries of the Desktop		*/
	CList		*itsWindows;			/* Application windows				*/
	CWindow		*topWindow;				/* Topmost visible window			*/
	
								/** Instance Methods **/
	void		IDesktop(CBureaucrat *aSupervisor);
	virtual void		Dispose();

	virtual void		Show(void);
	virtual void		Hide(void);
	virtual void		Activate(void);
	virtual void		Deactivate(void);
	virtual Boolean		ReallyVisible(void);
	
	virtual void		DispatchClick(EventRecord *macEvent);
	virtual void		DoMouseUp(EventRecord *macEvent);
	virtual void		DispatchCursor(Point where, RgnHandle mouseRgn);
	virtual void		AdjustCursor(Point where, RgnHandle mouseRgn);
	virtual Boolean		Contains(Point thePoint);
	virtual Boolean		HitSamePart(Point pointA, Point pointB);
	
	virtual void		AddWind(CWindow *theWindow);
	virtual void		RemoveWind(CWindow *theWindow);
	virtual void		SelectWind(CWindow *theWindow);
	virtual void		ShowWind(CWindow *theWindow);
	virtual void		HideWind(CWindow *theWindow);
	virtual void		DragWind(CWindow *theWindow, EventRecord *macEvent);
	virtual void		UpdateWindows(void);
	
	virtual CWindow*	GetTopWindow(void);
	virtual void		GetBounds(Rect *theBounds);
	virtual void		GetAperture(LongRect *theAperture);
	virtual void		Prepare(void);
};


void	Window_Show(CWindow *theWindow);
void	Window_Hide(CWindow *theWindow);
Boolean	Window_IsVisible(CWindow *theWindow);
