/******************************************************************************
 CDocument.h

		Interface for the Document Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- added MakePrinter, DoAppleEvent method
	]
		
 ******************************************************************************/
 
#define _H_CDocument

#include "CDirector.h"					/* Interface for its superclass		*/

	// Forward class declarations
	
class CApplication;
class CPane;
class CFile;
class CTask;
class CPrinter;

class CDocument : public CDirector {			/* Class Declaration				*/

public:
								/** Instance Variables **/
	CPane			*itsMainPane;
	CFile			*itsFile;
	CTask			*lastTask;
	Boolean			undone;				/* Has last task been undone?		*/
	CPrinter		*itsPrinter;
	Boolean			dirty;				/* Has the document changed?		*/
	short			pageWidth;
	short			pageHeight;
	
								/** Instance Methods **/
									/** Construction/Destruction **/
                                    
    
    void        IDocument( CApplication *aSupervisor, Boolean printable);
	virtual void		Dispose(void);

	virtual void		Notify(CTask *theTask);
	virtual void		DoCommand(long theCommand);
	virtual void		UpdateMenus(void);

	virtual Boolean		Close(Boolean quitting);
	virtual void		CloseWind(CWindow *theWindow);
	virtual Boolean		ConfirmClose(Boolean quitting);

	virtual void		NewFile(void);
	virtual void		OpenFile(SFReply *macSFReply);
	
									/** Printing **/
	virtual void		MakePrinter( void);
	virtual void		Paginate( void);
	virtual short		PageCount(void);
	virtual void		AboutToPrint(short *firstPage, short *lastPage);
	virtual void		PrintPageOfDoc(short pageNum);
	virtual void		DonePrinting(void);
	
									/** Filing **/
	virtual Boolean		DoSave(void);
	virtual Boolean		DoSaveAs(SFReply *macSFReply);
	virtual void		DoRevert(void);
	virtual Boolean		DoSaveFileAs(void);
	virtual void		PickFileName(SFReply *macSFReply);
	virtual void		GetName(Str255 theName);
	
	virtual void		UpdateUndo(void);
};

	// symbolic constants for Boolean parameters
enum
{
	kNotPrintable = FALSE,
	kPrintable
};