/******************************************************************************
 CList.h

		Interface for the List Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- CList is now a subclass of CArray (via CCluster).
		- The Remove method was removed because it is already implemented
		  in CCluster
		- changed prototyupes for FirstSuccess, FirstSuccess1, LastSuccess,
		  and LastSuccess1 to use the TestFunc typedef
	]
		
 ******************************************************************************/
 
#define _H_CList

#include "CCluster.h"					/* Interface for its superclass		*/

class CList : public CCluster {				/* Class Declaration				*/

public:
								/** Instance Variables **/
										/* None								*/
										
								/** Instance Methods **/
	void		IList(void);

	virtual void		Append(CObject *theObject);
	virtual void		Prepend(CObject *theObject);
	virtual void		InsertAfter(CObject *theObject, CObject *afterObject);
	virtual void		InsertAt(CObject *theObject, long index);
	
	virtual void		BringFront(CObject *theObject);
	virtual void		SendBack(CObject *theObject);
	virtual void		MoveUp(CObject *theObject);
	virtual void		MoveDown(CObject *theObject);
	virtual void		MoveToIndex(CObject *theObject, long index);
	
	virtual CObject*	FirstItem(void);
	virtual CObject*	LastItem(void);
	virtual CObject*	NthItem(long n);
	virtual long		FindIndex(CObject *theObject);
	virtual CObject*	FirstSuccess( TestFunc testFunc);
	virtual CObject*	FirstSuccess1(TestFunc1 testFunc, long param);
	virtual CObject*	LastSuccess( TestFunc testFunc);
	virtual CObject*	LastSuccess1( TestFunc1 testFunc, long param);
};

/* Change protocol for List class */

	/* This is just a redeclaration of the same protocol as CArray			*/
	/* redefined as "list" constants because lists are used so frequently	*/
	
enum /* reason parameter */				/* info parameter usage		*/
{
	listInsertElement = 1,				/* index of new element		*/
	listDeleteElement,					/* index of deleted element	*/
	listMoveElement,					/* pointer to tMovedElementInfo, see CArray */
	listElementChanged,					/* index of changed element	*/
	
	listLastChange = listElementChanged
};