/******************************************************************************
 CObject.h

		Interface for the Object Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- #include Exceptions.h
		- Declare Lock method
		- new() macro
	]
 ******************************************************************************/
 
#define _H_CObject

#include <oops.h>						/* THINK C interface for objects	*/
#include <Exceptions.h>					/* TCL Exception handling			*/


class CObject : indirect {					/* Class Declaration			*/

public:										
									/** Instance Methods **/
	virtual void		Dispose(void);
	virtual CObject		*Copy(void);
	virtual Boolean		Lock( Boolean fLock);
	virtual void		SubclassResponsibility( void);
	virtual void		GetClassName( Str255 className);

	void*		operator new( long objSize);
	void		operator delete( void* objStorage);
};
