/******************************************************************************
 CPicture.h

		Interface for the Picture Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/
 
#define _H_CPicture

#include "CPanorama.h"					/* Interface for its superclass		*/

class CPicture : public CPanorama {		/* Class Declaration				*/

public:
								/** Instance Variables **/
	PicHandle	macPicture;
	Boolean		scaled;
	Boolean		isResPicture;
	Boolean		ownsPicture;
	
								/** Instance Methods **/
	void		IPicture(CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							SizingOption aHSizing, SizingOption aVSizing);
	virtual void		IViewTemp(CView *anEnclosure, CBureaucrat *aSupervisor,
							Ptr viewData);
    
    virtual void        Dispose(void);

	virtual void		Draw(Rect *area);
	
	virtual void		SetMacPicture(PicHandle aMacPicture);
	virtual void		UsePICT(short PICTid);
	virtual PicHandle	GetMacPicture(void);
	virtual void		SetScaled(Boolean aScaled);
	virtual Boolean		GetScaled(void);
	virtual void		ResizeFrame(Rect *delta);
	virtual void		FrameToBounds(void);
};


typedef struct	{						/* Picture Pane template				*/
	PanoramaTemp	sPanoramaTemp;
	short			PICTid;
	short			scaled;
} PictureTemp, *PictureTempP;
