/******************************************************************************
 CSwitchboard.h

		Interface for the Switchboard Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- added GetAnEvent, DispatchEvent, DoHighLevelEvent, DoAppleEvent methods
		- added prototypes for AppleEventHandler and AppleEventIdleProc
		  callbacks.
	]

 ******************************************************************************/
 
#define _H_CSwitchboard

#include "CObject.h"					/* Interface for its superclass		*/

struct AppleEvent;

class CSwitchboard : public CObject {			/* Class Declaration				*/

public:
								/** Instance Variables **/
	RgnHandle		mouseRgn;			/* Region for mouse moved events	*/
	
								/** Instance Methods **/
	void	ISwitchboard(void);			/* Initialization					*/
	virtual void	DoMouseDown(EventRecord* macEvent);	/* Mouse button pressed				*/
	virtual void	DoMouseUp(EventRecord* macEvent);	/* Mouse button released			*/
	virtual void	DoKeyEvent(EventRecord* macEvent);	/* Keyboard event					*/
	virtual void	DoDiskEvent(EventRecord* macEvent);	/* Disk inserted					*/
	virtual void	DoUpdate(EventRecord* macEvent);	/* Update contents of a window		*/
	virtual void	DoActivate(EventRecord* macEvent);	/* Activate a window				*/
	virtual void	DoDeactivate(EventRecord* macEvent);/* Deactivate a window				*/
	virtual void	DoSuspend(EventRecord* macEvent);	/* Move to background under MF		*/
	virtual void	DoResume(EventRecord* macEvent);	/* Move to foreground under MF		*/
	virtual void	DoOtherEvent(EventRecord* macEvent);/* Anything else					*/
	virtual void	DoIdle(EventRecord* macEvent);		/* No event pending					*/
	virtual void	ProcessEvent(void);					/* process an event					*/
	virtual Boolean GetAnEvent( EventRecord* macEvent);	/* et event from the queue			*/
	virtual void	DispatchEvent( EventRecord* macEvent); /* handle an event				*/
	virtual void	DoHighLevelEvent(const EventRecord* macEvent);	/* Accept an AppleEvent	*/
	
	virtual OSErr	DoAppleEvent( struct AppleEvent *theEvent, struct AppleEvent *theReply, 
						long refCon);
						
	virtual Boolean AppleEventIdle( EventRecord *theEvent, long *sleepTime, 
				RgnHandle *mouseRgn);
};

#define		EventToWindow(e)	(CWindow*) GetWRefCon((WindowPtr)e->message)

	// prototypes for AppleEvent callback functions
	
pascal OSErr AppleEventHandler( struct AppleEvent *event, struct AppleEvent *reply, long refcon);
pascal short AppleEventIdleProc( EventRecord *theEvent, long *sleepTime, 
				RgnHandle *mouseRgn);
