/******************************************************************************
 CCollection.c

							The Collection Class
	
	Abstract class for a collection of objects arranged in some kind of
	data structure. The command ground for collections is that they
	contain zero or more items (objects).
	
	SUPERCLASS = CObject
	
	Copyright  1989 Symantec Corporation. All rights reserved.

	TCL 1.1 CHANGES
	[
		- ICollection now initializes new superclass CCollaborator
	]
 ******************************************************************************/

#include "Global.h"
#include "CCollection.h"
	

/******************************************************************************
 ICollection

		Initialize a Collection object
 ******************************************************************************/

void	CCollection::ICollection()
{
	CCollaborator::ICollaborator();
	
	numItems = 0L;						/* Start off with no items			*/
}
	

/******************************************************************************
 GetNumItems

		Return the number of items in the collection
 ******************************************************************************/

long	CCollection::GetNumItems()
{
	return(numItems);					/* Return instance variable			*/
}
	

/******************************************************************************
 IsEmpty

		Check whether the collection contains any items
 ******************************************************************************/

Boolean	CCollection::IsEmpty()
{	
	return(numItems == 0L);				/* Empty if size is zero			*/
}
