/******************************************************************************
 CDLOGDirector.c

		CDLOGDirector is a DialogDirector that creates its dialogs
		from DLOG/DITL resources. It may be used for both modal
		and modeless dialogs. Dialogs that are very simple, i.e.
		that require no custom behavior until the dialog is
		dismissed, can be implemented by using a CDLOGDirector.
		Anything more complex is best handled by subclassing CDLOGDirector
		and, at a minimum, overring the DoCommand method.
		
	SUPERCLASS = CDialogDirector
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#include "CDLOGDirector.h"
#include "CDLOGDialog.h"
#include "CDecorator.h"

extern struct CDesktop *gDesktop;
extern CDecorator *gDecorator;

/******************************************************************************
 IDLOGDirector
 
 	Initialize a DLOGDirector object. Creates a DLOGDialog using the
 	specified DLOGid.
******************************************************************************/

void CDLOGDirector::IDLOGDirector( short DLOGid,
		CDirectorOwner *aSupervisor)
{
	CDLOGDialog *dialog;
	
	CDialogDirector::IDialogDirector( aSupervisor);
	
	dialog = new( CDLOGDialog);
	itsWindow = dialog;
	
	dialog->IDLOGDialog( DLOGid, gDesktop, this);
	
	gDecorator->CenterWindow( dialog);

}