/******************************************************************************
 CSelector.h

		Interface for the Selector Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/
 
#define _H_CSelector

#include "CPanorama.h"					/* Interface for its superclass		*/

typedef enum {
	hiliteOFF,
	hiliteON,
	hiliteDYNAMIC
} HiliteState;

class CSelector : public CPanorama {	/* Class Declaration				*/

public:
								/** Instance Variables **/
	short		numItems;				/* Number of items to choose from	*/
	short		selection;				/* Currently selected item			*/
	short		commandBase;			/* Base value of selection command	*/
	
								/** Instance Methods **/
	void		ISelector(CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							SizingOption aHSizing, SizingOption aVSizing,
							short aNumItems, short aSelection,
							short aCommandBase);

	virtual void		DoClick(Point hitPt, short modifierKeys, long when);
	virtual Boolean		HitSamePart(Point pointA, Point pointB);

	virtual void		ChangeSelection(short aSelection);
	virtual short		GetSelection(void);
	virtual void		SetCommandBase(short aCommandBase);
	virtual short		GetCommandBase(void);
	virtual void		HiliteItem(short theItem, HiliteState state);
	virtual short		FindItem(Point hitPt);
	virtual void		DoDoubleClick(void);
};