/******************************************************************************
 CTearOffMenu.h

		Interface for the TearOffMenu Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/
 
#define _H_CTearOffMenu

#include "CDirector.h"					/* Interface for its superclass		*/
#include "CPane.h"
#include "CApplication.h"   

class CTearOffMenu : public CDirector {	/* Class Declaration				*/

public:
								/** Instance Variables **/
	CPane		*itsPane;				/* Pane displayed within menu		*/
	Point		corner;					/* Top left of torn-off window		*/
	Rect		margins;				/* Space between window bounds and	*/
										/*   and the pane within the window	*/
										/*   Includes space for the window	*/
										/*   frame and drag bar so that the	*/
										/*   correct dotted outline is		*/
										/*   drawn when menu is torn off	*/
	
								/** Instance Methods **/
    void        ITearOffMenu(CApplication *aSupervisor, short WINDid);

	virtual void		Suspend(void);
	virtual void		Resume(void);
	virtual void		CloseWind(CWindow *theWindow);
								
	virtual void		TornOff(Point aCorner);
	virtual void		MoveToCorner(void);
	virtual WindowPtr	GetMacWindow(void);
	virtual void		SetMargins(Rect *aMargins);
	virtual void		GetMargins(Rect *theMargins);
};