/******************************************************************************
 CTextEnvirons.c

							The TextEnvirons Class
		
	Stores and restores text characteristics.
	
	SUPERCLASS = CEnvironment
	
	Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/

#include "Global.h"
#include "CTextEnvirons.h"
	

/******************************************************************************
 ITextEnvirons

		Initialize a TextEnvirons object
 ******************************************************************************/

void	CTextEnvirons::ITextEnvirons()
{    
    textInfo.fontNumber = 0;
    textInfo.theSize = 0;
    textInfo.theStyle = 0;
    textInfo.theMode = 0;
}
	

/******************************************************************************
 Restore

		Restore the text environment
 ******************************************************************************/

void	CTextEnvirons::Restore()
{
	TextFont(textInfo.fontNumber);
	TextSize(textInfo.theSize);
	TextFace(textInfo.theStyle);
	TextMode(textInfo.theMode);
	PenNormal();
}	


/******************************************************************************
 SetTextInfo

		Set the text characteristics
 ******************************************************************************/

void	CTextEnvirons::SetTextInfo(
	TextInfoRec		*aTextInfo)
{
	textInfo = *aTextInfo;				/* Set instance variable			*/
}
	

/******************************************************************************
 GetTextInfo

		Get the text characteristics
 ******************************************************************************/

void	CTextEnvirons::GetTextInfo(
	TextInfoRec		*aTextInfo)
{
	*aTextInfo = textInfo;				/* Return instance variable			*/
}