/******************************************************************************
 CArrayPane.h

		Interface for ArrayPane class.
		
	SUPERCLASS = CTable
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#define _H_CArrayPane

#include "CTable.h"

class CArray;

class CArrayPane : public CTable
{
public:

	void IArrayPane( CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							SizingOption aHSizing, SizingOption aVSizing);

	virtual void	IViewTemp(CView *anEnclosure, CBureaucrat *aSupervisor,
							Ptr viewData);
	virtual void Dispose( void);
							
	void SetArray( CArray *anArray, Boolean fOwnership);
	virtual CArray *GetArray( void);
	virtual void ChangeSize( Rect *delta, Boolean redraw);

protected:

	CArray	*itsArray;		/* array being displayed						*/
	Boolean	ownsArray;		/* TRUE if Dispose should dispose of itsArray	*/
	
	
	virtual void ProviderChanged( CCollaborator *aProvider, long reason, void* info);	
};
