/******************************************************************************
 CStyleTEEditTask.h

		Interface for Styled TextEdit editing task
		
	SUPERCLASS = CTextEditTask
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/


#pragma once

#include "CTextEditTask.h"
#include "CStyleText.h"

class CStyleTEEditTask : public CTextEditTask
{
public:

	void 	IStyleTEEditTask( CStyleText *aTextPane, long anEditCmd, short firstTaskIndex);
	virtual void 	Dispose( void);

protected:

	TEHandle		macTE;				/* TEHandle of itsTextPane */
	StScrpHandle	origStyleScrap;		/* original styles on clipboard */
	StScrpHandle	deletedStyles;		/* styles of original text	*/
	StScrpHandle	insertedStyles;		/* styles of inserted text	*/
	
	virtual void 	DoBackspace( void);
	virtual void 	DoFwdDelete( void);

	virtual void 	SaveRange( tRangeSelector whichRange);
	virtual void 	RestoreRange( tRangeSelector whichRange, Boolean killData);
	virtual void 	StoreToClip( tClipSelector whichClip);
	
	virtual Boolean CheckNewStyle( ScrpSTElement *scrapEl, 
							StScrpHandle styleH, Boolean atStart);

};